      SUBROUTINE MAP_STEEL_PROGC(VMAX,T,XMAX,W,XBAR,HH,BOLTZ,R,PI)
C PROGRAM MODIFIED, 30-8-83, FOR ACCURATE XAPLPHA
C PROGRAM MODIFIED, 30-8-83, FOR ACCURATE CAPILLARITY CONSTANT CALCULATION
C PROGRAM TO CALCULATE THE EFFECTIVE DIFFUSIVITY OF CARBON IN
C AUSTENITE, TAKING ACCOUNT OF THE FACT THAT THIS DIFFUSIVITY
C IS CONCENTRATION DEPENDENT.  USES SILLER AND MCLELLAN THEORY
C TO EXPRESS THE CONCENTRATION DEPENDENCE, AND LACHER ET AL
C THEORY TO ALLOW FOR THE EFFECT OF SUBSTITUTIONAL ALLOYING ELEMENTS
C ON THE ACTIVITY AND W OF CARBON IN AUSTENITE. **7 OCTOBER 1981**
C 
C CARBON CONTENT AND ALLOYING CONTENT IS READ AS WT PCT
C FIRST LINE CONTAINS AN INTEGER INDICATING NUMBER OF TEMP,XMAX PAIRS
C TO BE CALCULATED PER ALLOY
      IMPLICIT NONE                              
      DOUBLE PRECISION VMAX,T,XMAX,W,XBAR,RADIUS,PSI
      DOUBLE PRECISION DIFF(1000),CARB(1000),A5,SIGMA
      DOUBLE PRECISION XALPHA,MAP_STEEL_XALPH,HH,BOLTZ
      DOUBLE PRECISION MAP_STEEL_CG,MAP_STEEL_DCG,ANS
      DOUBLE PRECISION M1,R,XMAXR,DASH,X,ACTIV,DACTIV
      DOUBLE PRECISION THETA,OMEG,RAD,DD,PI,DUMMY,PECLET
      DOUBLE PRECISION SIG,MOLVOL,CAPCON,EPSI
      INTEGER Z,II2,II3,II
C CAPCON IS THE CAPILLARITY CONSTANT (NORMALLY CAPITAL GAMMA)
C XMAXR IS THE EQUILIBRIUM CONC AT PLATE TIP OF RADIUS R, IN GAMMA
C HH=PLANCKS CONST.JOULES/SEC,BOLTZ=BOLTZMANNS CONST.JOULES/DEGREE KELVIN
      Z=12
      A5=1.0D+00
C     D=DIFFUSIVITY OF CARBON IN AUSTENITE
C     Z=COORDINATION OF INTERSTIAL SITE
C     PSI=COMPOSITION DEPENDENCE OF DIFFUSION COEFFICIENT
C     THETA=NO. C ATOMS/ NO. FE ATOMS
C     ACTIV=ACTIVITY OF CARBON IN AUSTENITE
C     R=GAS CONSTANT
C     X=MOLE FRACTION OF CARBON
C     T=ABSOLUTE TEMPERATURE
C     SIGMA=SITE EXCLUSION PROBABLITY
C     W=CARBON CARBON INTERACTION ENERGY IN AUSTENITE
      RADIUS=0.0
      VMAX=0.0
      M1=0.00
      II2=0
      XALPHA=MAP_STEEL_XALPH(T)
      CALL MAP_STEEL_RRAD(RADIUS,XMAX,XALPHA,XBAR,T,R,XMAXR,W,
     &SIG,MOLVOL,CAPCON,EPSI)
      DASH=(BOLTZ*T/HH)*DEXP(-(21230.0D+00/T))*DEXP(-31.84D+00)
      DO 999 II=1,1000
      CARB(1)=XBAR
      IF (II .GT. 1)GOTO 1000
      GOTO 1001
1000  CARB(II)=CARB(II-1)+0.0001D+00
      IF (CARB(II) .GT. XMAXR) GOTO 1002
1001  X=CARB(II)
      II2=II2+1
      THETA=X/(A5-X)
      ACTIV=MAP_STEEL_CG(X,T,W,R)
      ACTIV=DEXP(ACTIV)
      DACTIV=MAP_STEEL_DCG(X,T,W,R)
      DACTIV=DACTIV*ACTIV
      DACTIV=DACTIV*A5/((A5+THETA)**2)
      SIGMA=A5-DEXP((-(W))/(R*T))
      PSI=ACTIV*(A5+Z*((A5+THETA)/(A5-(A5+Z/2)*THETA+(Z/2)*(A5+Z/2)*
     &(A5-SIGMA)*THETA*THETA)))+(A5+THETA)*DACTIV
      DIFF(II)=DASH*PSI
999   CONTINUE
1002  II3=0
C     CALL D01GAF(CARB,DIFF,II2,ANS,ERROR,II3)
      CALL MAP_UTIL_TRAPE(CARB,DIFF,ANS,II2)
      ANS=ANS/(XMAXR-XBAR)
      CALL MAP_STEEL_VEL4(VMAX,ANS,RADIUS,XMAX,XBAR,XALPHA,
     &OMEG,DUMMY,PECLET,RAD,DD,PI)
      RETURN
      END
